<?php

declare(strict_types=1);

namespace App\Application;

use Symfony\Component\Translation\Translator;
use Symfony\Component\Translation\Loader\ArrayLoader;
use Twig\Extension\AbstractExtension;
use Twig\TwigFunction;

class TranslationExtension extends AbstractExtension
{
    private Translator $translator;

    public function __construct(Translator $translator)
    {
        $this->translator = $translator;
    }

    public function getFunctions(): array
    {
        return [
            new TwigFunction('trans', [$this, 'translate']),
        ];
    }

    public function translate(string $key, array $parameters = []): string
    {
        return $this->translator->trans($key, $parameters);
    }
}
